﻿using IdentityModel.Client;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace RetSoft.Demo.Desktop
{
    public partial class LoginForm : Form
    {
        private LoginForm()
        {
            InitializeComponent();
        }

        public HttpClient Client { get; private set; }

        private async void btnAuthorizeApiKey_Click(object sender, EventArgs e)
        {
            try
            {
                Enabled = false;
                if (tabControl.SelectedTab == tabPageAPIKey) // API Key; impersonation
                {
                    if (string.IsNullOrWhiteSpace(txtImpersonate.Text))
                    {
                        Client = await ConnectionManager.Authorize(txtAPIKey.Text, txtURL.Text);
                    }
                    else // Impersonate user
                    {
                        Client = await ConnectionManager.Impersonate(txtAPIKey.Text, txtURL.Text, txtImpersonate.Text);
                    }
                    
                }
                else // OAuth
                {
                    Client = await ConnectionManager.Authorize(txtClientId.Text, txtClientSecret.Text, txtURL.Text);
                }
                DialogResult = DialogResult.OK;
                Close();

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                Enabled = true;
            }
        }

        public static HttpClient PerformLogin()
        {
            using (var f = new LoginForm())
            { 
                if (f.ShowDialog() == DialogResult.OK)
                {
                    return f.Client;
                }
            }
            return null;
        }
    }
}
