﻿using Newtonsoft.Json;
using RetSoft.Demo.Desktop.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net.Http;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace RetSoft.Demo.Desktop
{
    public partial class SearchDemo : Form
    {
        private readonly HttpClient client;

        public SearchDemo(HttpClient client)
        {
            InitializeComponent();
            this.client = client;
        }

        private async void btnSearch_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(txtSearch.Text))
            {
                return;
            }

            try
            {
                Enabled = false;
                var request = new SearchRequest { Criteria = txtSearch.Text };
                var response = await client.PostAsJsonAsync("api/search", request);
                response.EnsureSuccessStatusCode();
                var result = await response.Content.ReadAsJsonAsync<SearchResponse>();
                // Add search results to list
                listBoxSearchResults.Items.Clear();
                foreach (var item in result.Results)
                {
                    listBoxSearchResults.Items.Add(item.Name);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                Enabled = true;
            }
        }
    }
}
